/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink_$type } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { LRUCache$2 } from "./LRUCache$2";
import { Base, runOn, Array_$type, Number_$type, typeCast, fromEnum, typeGetValue, String_$type, Boolean_$type, markType } from "./type";
import { IDataSourcePage_$type } from "./IDataSourcePage";
import { Dictionary$2 } from "./Dictionary$2";
import { SectionMap } from "./SectionMap";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { SectionData } from "./SectionData";
import { List$1 } from "./List$1";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { truncate, intDivide } from "./number";
/**
 * @hidden
 */
export let VirtualDataSource = /*@__PURE__*/ (() => {
    class VirtualDataSource extends BaseDataSource {
        constructor() {
            super();
            this.ci = null;
            this.cz = false;
            this.dl = 0;
            this.ct = null;
            this.cm = null;
            this.cl = null;
            this.dk = 50;
            this.dj = 200;
            this.actualPageSizePopulated = false;
            this.c5 = 50;
            this.cx = false;
            this.cq = null;
            this.cg = null;
            this.ch = null;
            this.cw = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
            this.c3 = new Dictionary$2(Base.$, Array_$type, 0);
            this.c4 = new Dictionary$2(Number_$type, Number_$type, 0);
            this.cy = false;
            this.ce = null;
            this.cj = null;
            this.cv = new SectionMap();
            this.cf = null;
            this.dd = -1;
            this.c6 = -1;
            this.df = -1;
            this.c8 = -1;
            this.dg = -1;
            this.c9 = -1;
            this.de = -1;
            this.c7 = -1;
            this.di = -1;
            this.dh = -1;
            this.db = -1;
            this.da = -1;
            this.dc = -1;
            this.c2 = new Dictionary$2(String_$type, Boolean_$type, 0);
            this.ct = new PagePredictionEngine();
            this.ct.e = this;
            this.ct.ag = this.actualPageSize;
            this.ct.f = this.cv;
            this.executionContext = new DataSourceExecutionContext();
            this.ct.b = this.executionContext;
        }
        get_isSectionCollapsable() {
            if (!this.isSectionContentVisible) {
                return true;
            }
            return super.get_isSectionCollapsable();
        }
        set_isSectionCollapsable(a) {
            super.set_isSectionCollapsable(a);
        }
        get_isSectionExpandedDefault() {
            if (!this.isSectionContentVisible) {
                return false;
            }
            if (this.isSectionCollapsable) {
                return super.get_isSectionExpandedDefault();
            }
            return true;
        }
        set_isSectionExpandedDefault(a) {
            super.set_isSectionExpandedDefault(a);
        }
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.cm;
        }
        set dataProvider(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.onPropertyUpdated("DataProvider", b, this.cm);
            }
        }
        get actualDataProvider() {
            if (this.cl == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.cl;
        }
        set actualDataProvider(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.onPropertyUpdated("ActualDataProvider", b, this.cl);
            }
        }
        get pageSizeRequested() {
            return this.dk;
        }
        set pageSizeRequested(a) {
            let b = this.dk;
            this.dk = a;
            if (b != this.dk) {
                this.onPropertyUpdated("PageSizeRequested", b, this.dk);
            }
        }
        resetCache() {
            if (this.cr != null) {
                this.cr.resetCache();
            }
            this.resetCacheOverride();
        }
        resetCacheOverride() {
            this.cw.i();
        }
        get maxCachedPages() {
            return this.dj;
        }
        set maxCachedPages(a) {
            let b = this.dj;
            this.dj = a;
            if (b != this.dj) {
                this.onPropertyUpdated("MaxCachedPages", b, this.dj);
            }
        }
        get actualPageSize() {
            return this.c5;
        }
        set actualPageSize(a) {
            let b = this.c5;
            this.c5 = a;
            if (b != this.c5) {
                this.onPropertyUpdated("ActualPageSize", b, this.c5);
            }
        }
        get_isSortingSupported() {
            if (this.externalDataSource != null && !this.cx) {
                this.cx = true;
                let a = this.externalDataSource.isSortingSupportedOverride;
                this.cx = false;
                return a;
            }
            return false;
        }
        get_isFilteringSupported() {
            if (this.externalDataSource != null && !this.cx) {
                this.cx = true;
                let a = this.externalDataSource.isFilteringSupportedOverride;
                this.cx = false;
                return a;
            }
            return false;
        }
        get_isGroupingSupported() {
            if (this.externalDataSource != null && !this.cx) {
                this.cx = true;
                let a = this.externalDataSource.isGroupingSupportedOverride;
                this.cx = false;
                return a;
            }
            return false;
        }
        get cr() {
            return this.cq;
        }
        set cr(a) {
            this.cq = a;
            this.actualDataProvider = this.resolveDataProvider();
        }
        resolveDataProvider() {
            if (this.cr == null) {
                return null;
            }
            return this.cr.resolveDataProvider();
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.actualDataProvider = this.dataProvider;
                    this.queueAutoRefresh();
                    break;
                case "ExecutionContext":
                    this.ct.b = this.executionContext;
                    break;
                case "ActualDataProvider":
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    this.actualDataProvider.pageLoaded = runOn(this, this.d4);
                    this.queueAutoRefresh();
                    break;
                case "PageSizeRequested":
                    this.actualPageSize = this.pageSizeRequested;
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    }
                    this.queueAutoRefresh();
                    break;
                case "ActualPageSize":
                    this.ct.ag = this.actualPageSize;
                    this.queueAutoRefresh();
                    break;
                case "FirstVisibleIndexRequested":
                    this.ct.aa = this.firstVisibleIndexRequested;
                    break;
                case "LastVisibleIndexRequested":
                    this.ct.ae = this.lastVisibleIndexRequested;
                    break;
                case "ActualCount":
                    if (this.actualDataProvider != null && !this.cv.q) {
                        this.ct.ab = this.actualDataProvider.actualCount;
                    }
                    else {
                        this.ct.ab = this.actualCount;
                    }
                    this.queueAutoRefresh();
                    break;
                case "MaxCachedPages":
                    this.cw.h = this.maxCachedPages;
                    break;
            }
        }
        dp(a) {
            if (this.aj && this.cv.q) {
                let b = this.cu(a);
                if (b == null) {
                    b = this.cv.d();
                }
                return a - b.t;
            }
            return a;
        }
        d4(a, b, c) {
            let d = this.executionContext;
            if (d != null) {
                d.execute(() => this.ea(a, b, c));
            }
            else {
                this.ea(a, b, c);
            }
        }
        ea(a, b, c) {
            if (a == null) {
                b = this.resolveFullCount(b);
                if (this.actualCount != b) {
                    this.actualCount = b;
                }
                return;
            }
            if (c != this.actualPageSize && !this.actualPageSizePopulated) {
                this.actualPageSize = c;
            }
            this.actualPageSizePopulated = true;
            let d = a.pageIndex();
            this.d5(d);
            this.cw.item(d, a);
            let e = a.schema();
            if (e != null) {
                this.actualSchema = e;
            }
            let f = a.getSummaryInformation();
            if (this.summaryDescriptions.k.count > 0 && this.cj == null && f != null) {
                this.cj = f;
                for (let g = 0; g < this.summaryDescriptions.k.count; g++) {
                    this.cj[g].summaryIndex = g;
                }
                let h = SectionData.r(this.cj);
                this.dl = h.count;
            }
            let i = a.getGroupInformation();
            if (this.groupDescriptions.k.count > 0 && this.ce == null && i != null) {
                this.ce = i;
                this.d9();
                this.cz = false;
            }
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            this.d8(a);
        }
        resolveFullCount(a) {
            if (this.ce != null) {
                return this.cv.u + this.dl;
            }
            return a + this.dl;
        }
        d9() {
            let a = 0;
            let b = 0;
            let c = this.shouldEmitSectionHeaders;
            let d = this.shouldEmitSectionFooters;
            for (let e = 0; e < this.ce.length; e++) {
                let f = new SectionData();
                let g = b;
                let h = this.ce[e].endIndex - this.ce[e].startIndex;
                f.af = a;
                f.ae = e;
                f.d = new Array(this.groupDescriptions.k.count);
                for (let i = 0; i < this.groupDescriptions.k.count; i++) {
                    f.d[i] = 0;
                }
                f.ad = a + h;
                f.t = 0;
                f.e = this.ce[e].groupKeyProperties;
                f.f = this.ce[e].groupKeyValues;
                f.h = new Array(0);
                f.ai(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
                this.d3(f, e == 0);
                if (d) {
                    f.u = f.c.length;
                }
                let j = 0;
                f.i = new Array(this.groupDescriptions.k.count);
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.ce[e].summaryResults != null) {
                        f.i[this.groupDescriptions.k.count - 1] = this.ce[e].summaryResults;
                        if (f.i != null) {
                            for (let k = 0; k < f.i[this.groupDescriptions.k.count - 1].length; k++) {
                                f.i[this.groupDescriptions.k.count - 1][k].summaryIndex = k;
                            }
                            j = SectionData.r(f.i[this.groupDescriptions.k.count - 1]).count;
                        }
                    }
                }
                if (this.includeSummaryRowsInSection) {
                    if (this.isSectionSummaryRowsAtBottom) {
                        f.ag = j;
                    }
                    else {
                        f.ah = j;
                        g += j;
                    }
                    b += j;
                    f.ad += j;
                }
                if (d) {
                    b++;
                }
                let l = 0;
                f.b = new Array(f.c.length);
                if (f.z > -1) {
                    let m = this.cv.t._inner[f.z];
                    for (let n = 0; n < m.f.length; n++) {
                        l = n;
                        if (!Base.equalsStatic(m.f[n], f.f[n])) {
                            break;
                        }
                    }
                }
                for (let o = l; o < f.c.length; o++) {
                    b++;
                    g++;
                    f.ad++;
                    let p = this.dy(f, o);
                    f.a[o] = p;
                    f.b[o] = o - l;
                    if (this.c2.containsKey(p)) {
                        f.c[o] = this.c2.item(p);
                    }
                    else {
                        f.c[o] = this.isSectionExpandedDefault;
                    }
                    if (!f.c[o]) {
                        let q = 0;
                        let r = f.c.length - 1 - o;
                        f.ad -= q;
                        b -= q;
                        if (d) {
                            b--;
                            f.u--;
                        }
                        o += r;
                    }
                }
                f.y = f.v();
                f.t = g;
                this.cv.z(f, h + 1);
                if (!f.p) {
                    let s = f.w();
                    f.ad -= f.d[s] + j;
                    b -= f.d[s] + j;
                }
                a = f.ad + 1;
                this.cv.t.add(f);
                f.q = this.cv.r(f);
            }
            let t = 0;
            for (let u = 0; u < this.cv.t.count; u++) {
                let v = this.cv.t._inner[u];
                if (this.shouldEmitSectionHeaders) {
                    if (!v.q) {
                        let w = v.ad - v.af + 1;
                        this.cv.ae(v.ae);
                        this.cv.ab(v, -w, -w);
                        u--;
                        t++;
                        continue;
                    }
                }
                if (v.z > -1) {
                    v.z -= t;
                }
            }
        }
        d3(a, b) {
            if (b) {
                this.cg = new Array(this.groupDescriptions.k.count);
                for (let c = 0; c < this.cg.length; c++) {
                    this.cg[c] = a;
                }
            }
            if (this.sectionHeaderDisplayMode == 1) {
                let d = false;
                let e = a.e.length;
                for (let f = 0; f < e; f++) {
                    if (d) {
                        this.cg[f] = a;
                        continue;
                    }
                    let g = false;
                    if (this.cg[f].f[f] == null) {
                        g = a.f[f] != null;
                    }
                    else {
                        g = !Base.equalsStatic(this.cg[f].f[f], a.f[f]);
                    }
                    if (g) {
                        this.cg[f] = a;
                        if (f - 1 > -1) {
                            let h = f - 1;
                            while (h >= 0 && this.cg[h].o) {
                                h = h - 1;
                            }
                            a.z = this.cg[h].ae;
                        }
                        d = true;
                    }
                }
            }
            else {
                let i = false;
                for (let j = 0; j < a.e.length; j++) {
                    if (this.cg[0].f[j] == null) {
                        if (this.cg[0].f[j] != a.f[j]) {
                            i = true;
                            break;
                        }
                        continue;
                    }
                    if (!Base.equalsStatic(this.cg[0].f[j], a.f[j])) {
                        i = true;
                        break;
                    }
                }
                if (i) {
                    this.cg[0] = a;
                }
            }
        }
        d2(a) {
        }
        d8(a) {
            if (this.updateNotifier != null) {
                let b = a.pageIndex() * this.actualPageSize;
                if (this.actualDataProvider != null) {
                    if (b > this.actualDataProvider.actualCount) {
                        return;
                    }
                }
                let c = this.dn(b);
                let d = this.dn(b + a.count() - 1);
                if (c > 0 && this.getRowType(c - 1) == 1) {
                    c--;
                }
                if (this.actualCount == 0 && a.count() == 0) {
                    this.onClearItems();
                }
                else {
                    this.updateNotifier.rangeActualized(c, d);
                }
            }
        }
        dn(a) {
            if (this.aj && this.cv.q) {
                let b = this.cv.g(a);
                if (b == null) {
                    b = this.cv.d();
                }
                if (!b.p) {
                    return b.af;
                }
                return a + b.t;
            }
            return a;
        }
        d6(a) {
            a();
        }
        get_isVirtual() {
            return true;
        }
        isPlaceholderItem(a) {
            let b = this.ck(a);
            let c = b[0];
            if (!this.cw.d(c)) {
                if (b[1] == -1) {
                    return false;
                }
                return true;
            }
            return false;
        }
        getItemAtIndex(a) {
            if (a >= this.actualCount - this.dl) {
                return this.dt(a);
            }
            let b = this.ck(a);
            let c = b[0];
            if (!this.cw.d(c)) {
                if (b[1] == -1) {
                    return this.dt(a);
                }
                return null;
            }
            let d = this.cw.item(c);
            let e = b[1];
            if (e == -1) {
                return this.dt(a);
            }
            return d.getItemAtIndex(e);
        }
        dt(a) {
            if (a >= this.actualCount - this.dl) {
                let b = new DataSourceSpecialRow();
                b.rowType = 4;
                b.level = 0;
                let c = a - (this.actualCount - this.dl);
                let d = SectionData.r(this.cj);
                let e = new Array(d._inner[c].count);
                d._inner[c].values.copyTo(e, 0);
                b.summaryResults = e;
                return b;
            }
            let f = this.cu(a);
            if (f != null) {
                let g = f.j(a);
                if (g == 1 || g == 2) {
                    let h = new DataSourceSpecialRow();
                    h.rowType = g;
                    h.summaryResults = f.i[f.i.length - 1];
                    h.level = g == 1 ? f.w() + (a - f.af) : (f.u - 1) - (f.w() + (a - (f.ad - f.u + 1)));
                    if (this.sectionHeaderDisplayMode == 0) {
                        for (let i = 0; i < this.groupDescriptions.k.count; i++) {
                            h.setSectionValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                            h.setValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                        }
                    }
                    else {
                        if (h.level >= 0 && h.level < this.groupDescriptions.k.count) {
                            h.setSectionValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                            h.setValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                        }
                    }
                    return h;
                }
                else if (g == 5) {
                    let j = new DataSourceSpecialRow();
                    j.rowType = 5;
                    j.level = f.c.length;
                    let k = f.x(a);
                    let l = SectionData.r(f.i[f.i.length - 1]);
                    let m = new Array(l._inner[k].count);
                    l._inner[k].values.copyTo(m, 0);
                    j.summaryResults = m;
                    return j;
                }
            }
            return null;
        }
        ck(a) {
            if (this.aj && this.cv.q) {
                let b = false;
                let c = this.cu(a);
                if (c == null) {
                    c = this.cv.d();
                    if (this.cj.length > 0 && a > c.ad) {
                        b = true;
                    }
                }
                let d = c.af;
                if (this.shouldEmitSectionHeaders && a >= d && a < d + c.v()) {
                    b = true;
                }
                if (a - (d + c.v() - 1) <= c.aa + c.ah) {
                    b = true;
                }
                if (this.shouldEmitSectionFooters) {
                    if (a <= c.ad && a >= c.ad - c.c.length - c.ag) {
                        b = true;
                    }
                }
                else if (c.ag > 0) {
                    if (a > c.ad - c.ag && a <= c.ad) {
                        b = true;
                    }
                }
                let e = a - c.t;
                let f = truncate(Math.floor(e / this.actualPageSize));
                let g = e % this.actualPageSize;
                if (b) {
                    g = -1;
                }
                let h = new Array(2);
                h[0] = f;
                h[1] = g;
                return h;
            }
            else {
                let i = truncate(Math.floor(a / this.actualPageSize));
                let j = a % this.actualPageSize;
                let k = new Array(2);
                k[0] = i;
                k[1] = j;
                return k;
            }
        }
        cu(a) {
            return this.cv.e(a);
        }
        getItemPropertyAtIndex(a, b) {
            if (a > (this.actualCount - 1) - this.dl) {
                return this.du(a, b);
            }
            let c = this.ck(a);
            let d = c[0];
            if (!this.cw.d(d)) {
                if (c[1] == -1) {
                    return this.du(a, b);
                }
                return null;
            }
            let e = this.cw.item(d);
            let f = c[1];
            if (f == -1) {
                return this.du(a, b);
            }
            return e.getItemValueAtIndex(f, b);
        }
        du(a, b) {
            let c = this.dt(a);
            if (typeCast(DataSourceSpecialRow.$, c) !== null) {
                return c.getValue(b);
            }
            return null;
        }
        d7(a) {
            if (!this.c4.containsKey(a)) {
                this.c4.addItem(a, 1);
            }
            else {
                this.c4.item(a, this.c4.item(a) + 1);
            }
        }
        d5(a) {
            if (this.c4.containsKey(a)) {
                this.c4.item(a, this.c4.item(a) - 1);
                if (this.c4.item(a) <= 0) {
                    this.c4.removeItem(a);
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.removePageRequest(a);
                    }
                }
            }
        }
        addCandidate(a, b) {
            let c = false;
            if (!this.c3.containsKey(a)) {
                let d = new List$1(Number_$type, 0);
                let e = this.transformPage(a);
                for (let f = 0; f < e.length; f++) {
                    let g = e[f];
                    if (!this.cw.d(g)) {
                        d.add(g);
                        this.d7(g);
                        let h = this.c4.item(g);
                        if (h == 1 && this.actualDataProvider != null) {
                            this.actualDataProvider.addPageRequest(g, b);
                        }
                        c = true;
                    }
                }
                if (d.count > 0) {
                    this.c3.addItem(a, d.toArray());
                }
            }
            return c;
        }
        removeCandidate(a) {
            if (this.c3.containsKey(a)) {
                for (let b = 0; b < this.c3.item(a).length; b++) {
                    let c = this.c3.item(a)[b];
                    this.d5(c);
                }
                this.c3.removeItem(a);
            }
        }
        transformPage(a) {
            let b = [a];
            if (this.aj && this.cv.q) {
                let c = a * this.actualPageSize;
                let d = c + this.actualPageSize - 1;
                let e = this.cu(c);
                let f = new List$1(Number_$type, 0);
                for (let g = c; g <= d; g++) {
                    if (e == null) {
                        break;
                    }
                    if (g > e.ad) {
                        if (e.ae < this.cv.t.count - 1) {
                            e = this.cv.t._inner[e.ae + 1];
                        }
                        else {
                            break;
                        }
                    }
                    if (!e.p || (g >= e.af && g <= e.af + (e.v() - 1) + e.aa)) {
                        continue;
                    }
                    let h = g - e.t;
                    let i = intDivide(h, this.actualPageSize);
                    if (!f.contains(i)) {
                        f.add(i);
                    }
                }
                b = f.toArray();
            }
            return b;
        }
        getUnrealizedCount() {
            let a = this.cw.g * this.actualPageSize;
            let b = this.actualCount - a;
            return b;
        }
        onSetItemOverride(a, b, c) {
            super.onSetItemOverride(a, b, c);
            let d = this.ck(a);
            let e = d[0];
            if (this.cw.d(e)) {
                this.cw.j(e);
            }
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            this.actualPageSizePopulated = false;
            let a = this.actualCount != 0;
            this.cy = true;
            if (!this.cz) {
                this.resetCache();
                if (a) {
                    this.onClearItems();
                }
                this.ce = null;
                this.cj = null;
                this.dl = 0;
                this.cv.v();
            }
            else {
                this.cz = false;
                if (a) {
                    this.onClearItems();
                }
            }
            this.eb();
            this.ct.au();
            this.cy = false;
        }
        eb() {
            if (this.actualDataProvider != null) {
                for (let a of fromEnum(this.c3.values)) {
                    for (let c = 0; c < a.length; c++) {
                        let b = a[c];
                        this.actualDataProvider.addPageRequest(b, 1);
                    }
                }
            }
        }
        onClearItemsOverride() {
            super.onClearItemsOverride();
            if (!this.cy) {
                this.queueAutoRefresh();
            }
        }
        onInsertItemOverride(a, b) {
            super.onInsertItemOverride(a, b);
            this.queueAutoRefresh();
        }
        onRemoveItemOverride(a, b) {
            super.onRemoveItemOverride(a, b);
            this.queueAutoRefresh();
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            let b = this.cw.b;
            let c = b.o;
            let d = b.q;
            let e = d.count;
            let f = b.p;
            for (let g = 0; g < e; g++) {
                if (f._inner[g]) {
                    continue;
                }
                let h = d._inner[g].b;
                let i = h.count();
                for (let j = 0; j < i; j++) {
                    if (this.c1(h.getItemAtIndex(j), a)) {
                        let k = typeGetValue(c._inner[g]);
                        let l = k * this.actualPageSize;
                        return l + j;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            return -1;
        }
        c1(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return -1;
            }
            this.ensureComparables(this.actualSchema);
            let c = this.cs();
            if (this.aj && this.shouldEmitSectionHeaders && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                if (this.cv.t.count > 0) {
                    for (let d = 0; d < this.cv.t.count; d++) {
                        let e = this.cv.t._inner[d];
                        let f = new DataSourceSpecialRow();
                        for (let g = 0; g < e.e.length; g++) {
                            let h = e.e[g];
                            let i = e.f[g];
                            f.setSectionValue(h, i);
                        }
                        if (c.i(f, a) == 0) {
                            return d;
                        }
                    }
                }
            }
            let j = this.cw.b;
            let k = j.o;
            let l = j.q;
            let m = l.count;
            let n = j.p;
            for (let o = 0; o < m; o++) {
                if (n._inner[o]) {
                    continue;
                }
                let p = l._inner[o].b;
                let q = p.count();
                for (let r = 0; r < q; r++) {
                    if (c.i(p.getItemAtIndex(r), a) == 0) {
                        let s = typeGetValue(k._inner[o]);
                        let t = s * this.actualPageSize;
                        return t + r;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            return -1;
        }
        cs() {
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.ci, this);
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        unpinRow(a) {
            super.unpinRow(a);
        }
        pinRow(a) {
            super.pinRow(a);
        }
        isRowPinned(a) {
            return super.isRowPinned(a);
        }
        getStickyRowsInRange(a, b) {
            if ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0)) {
                return null;
            }
            let c = this.cu(a);
            let d = this.cu(b);
            if (this.cv.t.count > 0) {
                if (this.cv.t.count == 1) {
                    c = this.cv.t._inner[0];
                    d = this.cv.t._inner[0];
                }
                else {
                    c = this.cv.e(a);
                    if (c != null) {
                        while (c.z != -1) {
                            c = this.cv.t._inner[c.z];
                        }
                    }
                    d = this.cv.e(b);
                    if (b >= this.actualCount - this.dl) {
                        d = this.cv.d();
                    }
                }
            }
            else if (this.dl > 0) {
                let e = new List$1(Number_$type, 0);
                for (let f = this.actualCount - this.dl; f < this.actualCount; f++) {
                    e.add(f);
                }
                return e.toArray();
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.ae == this.dd && c.aa == this.df && c.af == this.dg && c.ad == this.de && c.ah == this.di && c.ag == this.dh && d.ae == this.c6 && d.aa == this.c8 && d.af == this.c9 && d.ad == this.c7 && d.ah == this.db && d.ag == this.da && this.dl == this.dc) {
                return this.cf;
            }
            this.dd = c.ae;
            this.c6 = d.ae;
            this.df = c.aa;
            this.c8 = d.aa;
            this.dg = c.af;
            this.c9 = d.af;
            this.de = c.ad;
            this.c7 = d.ad;
            this.db = d.ah;
            this.da = d.ag;
            this.di = c.ah;
            this.dh = c.ag;
            this.dc = this.dl;
            let g = new List$1(Number_$type, 0);
            for (let h = c.ae; h <= d.ae; h++) {
                let i = this.cv.t._inner[h];
                let j = i.c.length;
                let k = i.v();
                if (this.shouldEmitSectionHeaders && this.aj) {
                    for (let l = 0; l < i.c.length; l++) {
                        if (i.a[l] != null) {
                            let m = i.af + i.b[l];
                            g.add(m);
                        }
                        if (!i.c[l]) {
                            break;
                        }
                    }
                }
                if (i.p) {
                    for (let n = 0; n < i.ah; n++) {
                        g.add(i.af + n + k);
                    }
                    if (this.shouldEmitShiftedRows) {
                        for (let o = 0; o < i.aa; o++) {
                            g.add(i.af + o + j);
                        }
                    }
                    if (this.summaryScope == 0 || this.summaryScope == 2) {
                        if (this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                            for (let p = i.ag - 1; p >= 0; p--) {
                                if (this.shouldEmitSectionFooters) {
                                    g.add(i.ad - k - p);
                                }
                                else {
                                    g.add(i.ad - p);
                                }
                            }
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.aj) {
                    for (let q = i.c.length - 1; q >= 0; q--) {
                        if (!i.c[q]) {
                            break;
                        }
                        g.add(i.ad - q);
                    }
                }
            }
            for (let r = this.actualCount - this.dl; r < this.actualCount; r++) {
                g.add(r);
            }
            this.cf = g.toArray();
            return this.cf;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                let c = b.rowType;
                if (this.isSectionHeaderNormalRow && c == 1) {
                    return 0;
                }
                return c;
            }
            return 0;
        }
        getIsRowExpandedAtIndex(a) {
            let b = this.cv.e(a);
            if (b == null) {
                b = this.cv.d();
            }
            for (let c = 0; c < b.a.length; c++) {
                if (b.a[c] != null) {
                    if (a == b.af + b.b[c]) {
                        return b.c[c];
                    }
                }
            }
            return super.getIsRowExpandedAtIndex(a);
        }
        setIsRowExpandedAtIndex(a, b) {
            let c = this.cv.e(a);
            if (c == null) {
                c = this.cv.d();
            }
            for (let d = 0; d < c.a.length; d++) {
                if (c.a[d] != null) {
                    if (a == c.af + c.b[d]) {
                        let e = false;
                        let f = c.a[d];
                        if (this.c2.containsKey(f) && this.c2.item(f) != b) {
                            let g = this.c2.item(f);
                            if (b == this.isSectionExpandedDefault) {
                                this.c2.removeItem(f);
                            }
                            else {
                                this.c2.item(f, b);
                            }
                            e = true;
                            this.onRowExpansionChanged(a, g, b);
                        }
                        else if (b != this.isSectionExpandedDefault) {
                            this.c2.addItem(f, b);
                            e = true;
                            this.onRowExpansionChanged(a, this.isSectionExpandedDefault, b);
                        }
                        if (e) {
                            this.cv.v();
                            this.d9();
                            this.cz = true;
                            if (this.actualCount != this.cv.u) {
                                this.actualCount = this.cv.u + this.dl;
                            }
                            else {
                                this.queueAutoRefresh();
                            }
                        }
                        break;
                    }
                }
            }
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.isGroupingSupported) {
                if (this.sectionHeaderDisplayMode == 1) {
                    return this.groupDescriptions.k.count;
                }
                else if (this.groupDescriptions.k.count > 0) {
                    return 1;
                }
            }
            return 0;
        }
        getRootSummaryRowCount() {
            return this.dl;
        }
        dx(a) {
            let b = "";
            for (let c = 0; c < a.e.length; c++) {
                b += a.e[c] + ":" + a.f[c];
            }
            return b;
        }
        dy(a, b) {
            if (this.sectionHeaderDisplayMode == 0) {
                return this.dx(a);
            }
            let c = "";
            for (let d = 0; d < a.e.length; d++) {
                c += a.e[d] + ":" + a.f[d] + ":";
            }
            c += b;
            return c;
        }
        getRootSummaryResults() {
            return this.cj;
        }
        getSectionSummaryResults(a) {
            if (this.cv.t.count > 0 && a >= 0 && a < this.cv.t.count) {
                return this.cv.t._inner[a].i;
            }
            return null;
        }
        clone() {
            return null;
        }
        cloneProperties(a) {
            super.cloneProperties(a);
            let b = typeCast(VirtualDataSource.$, a);
            if (b != null) {
                b.pageSizeRequested = this.pageSizeRequested;
                b.maxCachedPages = this.maxCachedPages;
            }
        }
    }
    VirtualDataSource.$t = /*@__PURE__*/ markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
    return VirtualDataSource;
})();
//# sourceMappingURL=VirtualDataSource.js.map
