/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink_$type } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { LRUCache$2 } from "./LRUCache$2";
import { Base, runOn, Array_$type, Number_$type, typeCast, fromEnum, typeGetValue, String_$type, Boolean_$type, markType } from "./type";
import { IDataSourcePage_$type } from "./IDataSourcePage";
import { Dictionary$2 } from "./Dictionary$2";
import { SectionMap } from "./SectionMap";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { SectionData } from "./SectionData";
import { List$1 } from "./List$1";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { truncate, intDivide } from "./number";
/**
 * @hidden
 */
var VirtualDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(VirtualDataSource, _super);
    function VirtualDataSource() {
        var _this = _super.call(this) || this;
        _this.ci = null;
        _this.cz = false;
        _this.dl = 0;
        _this.ct = null;
        _this.cm = null;
        _this.cl = null;
        _this.dk = 50;
        _this.dj = 200;
        _this.actualPageSizePopulated = false;
        _this.c5 = 50;
        _this.cx = false;
        _this.cq = null;
        _this.cg = null;
        _this.ch = null;
        _this.cw = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
        _this.c3 = new Dictionary$2(Base.$, Array_$type, 0);
        _this.c4 = new Dictionary$2(Number_$type, Number_$type, 0);
        _this.cy = false;
        _this.ce = null;
        _this.cj = null;
        _this.cv = new SectionMap();
        _this.cf = null;
        _this.dd = -1;
        _this.c6 = -1;
        _this.df = -1;
        _this.c8 = -1;
        _this.dg = -1;
        _this.c9 = -1;
        _this.de = -1;
        _this.c7 = -1;
        _this.di = -1;
        _this.dh = -1;
        _this.db = -1;
        _this.da = -1;
        _this.dc = -1;
        _this.c2 = new Dictionary$2(String_$type, Boolean_$type, 0);
        _this.ct = new PagePredictionEngine();
        _this.ct.e = _this;
        _this.ct.ag = _this.actualPageSize;
        _this.ct.f = _this.cv;
        _this.executionContext = new DataSourceExecutionContext();
        _this.ct.b = _this.executionContext;
        return _this;
    }
    VirtualDataSource.prototype.get_isSectionCollapsable = function () {
        if (!this.isSectionContentVisible) {
            return true;
        }
        return _super.prototype.get_isSectionCollapsable.call(this);
    };
    VirtualDataSource.prototype.set_isSectionCollapsable = function (a) {
        _super.prototype.set_isSectionCollapsable.call(this, a);
    };
    VirtualDataSource.prototype.get_isSectionExpandedDefault = function () {
        if (!this.isSectionContentVisible) {
            return false;
        }
        if (this.isSectionCollapsable) {
            return _super.prototype.get_isSectionExpandedDefault.call(this);
        }
        return true;
    };
    VirtualDataSource.prototype.set_isSectionExpandedDefault = function (a) {
        _super.prototype.set_isSectionExpandedDefault.call(this, a);
    };
    VirtualDataSource.prototype.get_actualBaseDataProvider = function () {
        return this.actualDataProvider;
    };
    Object.defineProperty(VirtualDataSource.prototype, "actualBaseDataProvider", {
        get: function () {
            return this.get_actualBaseDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "dataProvider", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.onPropertyUpdated("DataProvider", b, this.cm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "actualDataProvider", {
        get: function () {
            if (this.cl == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.onPropertyUpdated("ActualDataProvider", b, this.cl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "pageSizeRequested", {
        get: function () {
            return this.dk;
        },
        set: function (a) {
            var b = this.dk;
            this.dk = a;
            if (b != this.dk) {
                this.onPropertyUpdated("PageSizeRequested", b, this.dk);
            }
        },
        enumerable: true,
        configurable: true
    });
    VirtualDataSource.prototype.resetCache = function () {
        if (this.cr != null) {
            this.cr.resetCache();
        }
        this.resetCacheOverride();
    };
    VirtualDataSource.prototype.resetCacheOverride = function () {
        this.cw.i();
    };
    Object.defineProperty(VirtualDataSource.prototype, "maxCachedPages", {
        get: function () {
            return this.dj;
        },
        set: function (a) {
            var b = this.dj;
            this.dj = a;
            if (b != this.dj) {
                this.onPropertyUpdated("MaxCachedPages", b, this.dj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "actualPageSize", {
        get: function () {
            return this.c5;
        },
        set: function (a) {
            var b = this.c5;
            this.c5 = a;
            if (b != this.c5) {
                this.onPropertyUpdated("ActualPageSize", b, this.c5);
            }
        },
        enumerable: true,
        configurable: true
    });
    VirtualDataSource.prototype.get_isSortingSupported = function () {
        if (this.externalDataSource != null && !this.cx) {
            this.cx = true;
            var a = this.externalDataSource.isSortingSupportedOverride;
            this.cx = false;
            return a;
        }
        return false;
    };
    VirtualDataSource.prototype.get_isFilteringSupported = function () {
        if (this.externalDataSource != null && !this.cx) {
            this.cx = true;
            var a = this.externalDataSource.isFilteringSupportedOverride;
            this.cx = false;
            return a;
        }
        return false;
    };
    VirtualDataSource.prototype.get_isGroupingSupported = function () {
        if (this.externalDataSource != null && !this.cx) {
            this.cx = true;
            var a = this.externalDataSource.isGroupingSupportedOverride;
            this.cx = false;
            return a;
        }
        return false;
    };
    Object.defineProperty(VirtualDataSource.prototype, "cr", {
        get: function () {
            return this.cq;
        },
        set: function (a) {
            this.cq = a;
            this.actualDataProvider = this.resolveDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    VirtualDataSource.prototype.resolveDataProvider = function () {
        if (this.cr == null) {
            return null;
        }
        return this.cr.resolveDataProvider();
    };
    VirtualDataSource.prototype.propertyUpdatedOverride = function (a, b, c) {
        _super.prototype.propertyUpdatedOverride.call(this, a, b, c);
        switch (a) {
            case "DataProvider":
                this.actualDataProvider = this.dataProvider;
                this.queueAutoRefresh();
                break;
            case "ExecutionContext":
                this.ct.b = this.executionContext;
                break;
            case "ActualDataProvider":
                this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                this.actualDataProvider.pageLoaded = runOn(this, this.d4);
                this.queueAutoRefresh();
                break;
            case "PageSizeRequested":
                this.actualPageSize = this.pageSizeRequested;
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                }
                this.queueAutoRefresh();
                break;
            case "ActualPageSize":
                this.ct.ag = this.actualPageSize;
                this.queueAutoRefresh();
                break;
            case "FirstVisibleIndexRequested":
                this.ct.aa = this.firstVisibleIndexRequested;
                break;
            case "LastVisibleIndexRequested":
                this.ct.ae = this.lastVisibleIndexRequested;
                break;
            case "ActualCount":
                if (this.actualDataProvider != null && !this.cv.q) {
                    this.ct.ab = this.actualDataProvider.actualCount;
                }
                else {
                    this.ct.ab = this.actualCount;
                }
                this.queueAutoRefresh();
                break;
            case "MaxCachedPages":
                this.cw.h = this.maxCachedPages;
                break;
        }
    };
    VirtualDataSource.prototype.dp = function (a) {
        if (this.aj && this.cv.q) {
            var b = this.cu(a);
            if (b == null) {
                b = this.cv.d();
            }
            return a - b.t;
        }
        return a;
    };
    VirtualDataSource.prototype.d4 = function (a, b, c) {
        var _this = this;
        var d = this.executionContext;
        if (d != null) {
            d.execute(function () { return _this.ea(a, b, c); });
        }
        else {
            this.ea(a, b, c);
        }
    };
    VirtualDataSource.prototype.ea = function (a, b, c) {
        if (a == null) {
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            return;
        }
        if (c != this.actualPageSize && !this.actualPageSizePopulated) {
            this.actualPageSize = c;
        }
        this.actualPageSizePopulated = true;
        var d = a.pageIndex();
        this.d5(d);
        this.cw.item(d, a);
        var e = a.schema();
        if (e != null) {
            this.actualSchema = e;
        }
        var f = a.getSummaryInformation();
        if (this.summaryDescriptions.k.count > 0 && this.cj == null && f != null) {
            this.cj = f;
            for (var g = 0; g < this.summaryDescriptions.k.count; g++) {
                this.cj[g].summaryIndex = g;
            }
            var h = SectionData.r(this.cj);
            this.dl = h.count;
        }
        var i = a.getGroupInformation();
        if (this.groupDescriptions.k.count > 0 && this.ce == null && i != null) {
            this.ce = i;
            this.d9();
            this.cz = false;
        }
        b = this.resolveFullCount(b);
        if (this.actualCount != b) {
            this.actualCount = b;
        }
        this.d8(a);
    };
    VirtualDataSource.prototype.resolveFullCount = function (a) {
        if (this.ce != null) {
            return this.cv.u + this.dl;
        }
        return a + this.dl;
    };
    VirtualDataSource.prototype.d9 = function () {
        var a = 0;
        var b = 0;
        var c = this.shouldEmitSectionHeaders;
        var d = this.shouldEmitSectionFooters;
        for (var e = 0; e < this.ce.length; e++) {
            var f = new SectionData();
            var g = b;
            var h = this.ce[e].endIndex - this.ce[e].startIndex;
            f.af = a;
            f.ae = e;
            f.d = new Array(this.groupDescriptions.k.count);
            for (var i = 0; i < this.groupDescriptions.k.count; i++) {
                f.d[i] = 0;
            }
            f.ad = a + h;
            f.t = 0;
            f.e = this.ce[e].groupKeyProperties;
            f.f = this.ce[e].groupKeyValues;
            f.h = new Array(0);
            f.ai(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
            this.d3(f, e == 0);
            if (d) {
                f.u = f.c.length;
            }
            var j = 0;
            f.i = new Array(this.groupDescriptions.k.count);
            if (this.summaryScope == 0 || this.summaryScope == 2) {
                if (this.ce[e].summaryResults != null) {
                    f.i[this.groupDescriptions.k.count - 1] = this.ce[e].summaryResults;
                    if (f.i != null) {
                        for (var k = 0; k < f.i[this.groupDescriptions.k.count - 1].length; k++) {
                            f.i[this.groupDescriptions.k.count - 1][k].summaryIndex = k;
                        }
                        j = SectionData.r(f.i[this.groupDescriptions.k.count - 1]).count;
                    }
                }
            }
            if (this.includeSummaryRowsInSection) {
                if (this.isSectionSummaryRowsAtBottom) {
                    f.ag = j;
                }
                else {
                    f.ah = j;
                    g += j;
                }
                b += j;
                f.ad += j;
            }
            if (d) {
                b++;
            }
            var l = 0;
            f.b = new Array(f.c.length);
            if (f.z > -1) {
                var m = this.cv.t._inner[f.z];
                for (var n = 0; n < m.f.length; n++) {
                    l = n;
                    if (!Base.equalsStatic(m.f[n], f.f[n])) {
                        break;
                    }
                }
            }
            for (var o = l; o < f.c.length; o++) {
                b++;
                g++;
                f.ad++;
                var p = this.dy(f, o);
                f.a[o] = p;
                f.b[o] = o - l;
                if (this.c2.containsKey(p)) {
                    f.c[o] = this.c2.item(p);
                }
                else {
                    f.c[o] = this.isSectionExpandedDefault;
                }
                if (!f.c[o]) {
                    var q = 0;
                    var r = f.c.length - 1 - o;
                    f.ad -= q;
                    b -= q;
                    if (d) {
                        b--;
                        f.u--;
                    }
                    o += r;
                }
            }
            f.y = f.v();
            f.t = g;
            this.cv.z(f, h + 1);
            if (!f.p) {
                var s = f.w();
                f.ad -= f.d[s] + j;
                b -= f.d[s] + j;
            }
            a = f.ad + 1;
            this.cv.t.add(f);
            f.q = this.cv.r(f);
        }
        var t = 0;
        for (var u = 0; u < this.cv.t.count; u++) {
            var v = this.cv.t._inner[u];
            if (this.shouldEmitSectionHeaders) {
                if (!v.q) {
                    var w = v.ad - v.af + 1;
                    this.cv.ae(v.ae);
                    this.cv.ab(v, -w, -w);
                    u--;
                    t++;
                    continue;
                }
            }
            if (v.z > -1) {
                v.z -= t;
            }
        }
    };
    VirtualDataSource.prototype.d3 = function (a, b) {
        if (b) {
            this.cg = new Array(this.groupDescriptions.k.count);
            for (var c = 0; c < this.cg.length; c++) {
                this.cg[c] = a;
            }
        }
        if (this.sectionHeaderDisplayMode == 1) {
            var d = false;
            var e = a.e.length;
            for (var f = 0; f < e; f++) {
                if (d) {
                    this.cg[f] = a;
                    continue;
                }
                var g = false;
                if (this.cg[f].f[f] == null) {
                    g = a.f[f] != null;
                }
                else {
                    g = !Base.equalsStatic(this.cg[f].f[f], a.f[f]);
                }
                if (g) {
                    this.cg[f] = a;
                    if (f - 1 > -1) {
                        var h = f - 1;
                        while (h >= 0 && this.cg[h].o) {
                            h = h - 1;
                        }
                        a.z = this.cg[h].ae;
                    }
                    d = true;
                }
            }
        }
        else {
            var i = false;
            for (var j = 0; j < a.e.length; j++) {
                if (this.cg[0].f[j] == null) {
                    if (this.cg[0].f[j] != a.f[j]) {
                        i = true;
                        break;
                    }
                    continue;
                }
                if (!Base.equalsStatic(this.cg[0].f[j], a.f[j])) {
                    i = true;
                    break;
                }
            }
            if (i) {
                this.cg[0] = a;
            }
        }
    };
    VirtualDataSource.prototype.d2 = function (a) {
    };
    VirtualDataSource.prototype.d8 = function (a) {
        if (this.updateNotifier != null) {
            var b = a.pageIndex() * this.actualPageSize;
            if (this.actualDataProvider != null) {
                if (b > this.actualDataProvider.actualCount) {
                    return;
                }
            }
            var c = this.dn(b);
            var d = this.dn(b + a.count() - 1);
            if (c > 0 && this.getRowType(c - 1) == 1) {
                c--;
            }
            if (this.actualCount == 0 && a.count() == 0) {
                this.onClearItems();
            }
            else {
                this.updateNotifier.rangeActualized(c, d);
            }
        }
    };
    VirtualDataSource.prototype.dn = function (a) {
        if (this.aj && this.cv.q) {
            var b = this.cv.g(a);
            if (b == null) {
                b = this.cv.d();
            }
            if (!b.p) {
                return b.af;
            }
            return a + b.t;
        }
        return a;
    };
    VirtualDataSource.prototype.d6 = function (a) {
        a();
    };
    VirtualDataSource.prototype.get_isVirtual = function () {
        return true;
    };
    VirtualDataSource.prototype.isPlaceholderItem = function (a) {
        var b = this.ck(a);
        var c = b[0];
        if (!this.cw.d(c)) {
            if (b[1] == -1) {
                return false;
            }
            return true;
        }
        return false;
    };
    VirtualDataSource.prototype.getItemAtIndex = function (a) {
        if (a >= this.actualCount - this.dl) {
            return this.dt(a);
        }
        var b = this.ck(a);
        var c = b[0];
        if (!this.cw.d(c)) {
            if (b[1] == -1) {
                return this.dt(a);
            }
            return null;
        }
        var d = this.cw.item(c);
        var e = b[1];
        if (e == -1) {
            return this.dt(a);
        }
        return d.getItemAtIndex(e);
    };
    VirtualDataSource.prototype.dt = function (a) {
        if (a >= this.actualCount - this.dl) {
            var b = new DataSourceSpecialRow();
            b.rowType = 4;
            b.level = 0;
            var c = a - (this.actualCount - this.dl);
            var d = SectionData.r(this.cj);
            var e = new Array(d._inner[c].count);
            d._inner[c].values.copyTo(e, 0);
            b.summaryResults = e;
            return b;
        }
        var f = this.cu(a);
        if (f != null) {
            var g = f.j(a);
            if (g == 1 || g == 2) {
                var h = new DataSourceSpecialRow();
                h.rowType = g;
                h.summaryResults = f.i[f.i.length - 1];
                h.level = g == 1 ? f.w() + (a - f.af) : (f.u - 1) - (f.w() + (a - (f.ad - f.u + 1)));
                if (this.sectionHeaderDisplayMode == 0) {
                    for (var i = 0; i < this.groupDescriptions.k.count; i++) {
                        h.setSectionValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                        h.setValue(this.groupDescriptions.k.item(i).propertyName, f.f[i]);
                    }
                }
                else {
                    if (h.level >= 0 && h.level < this.groupDescriptions.k.count) {
                        h.setSectionValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                        h.setValue(this.groupDescriptions.k.item(h.level).propertyName, f.f[h.level]);
                    }
                }
                return h;
            }
            else if (g == 5) {
                var j = new DataSourceSpecialRow();
                j.rowType = 5;
                j.level = f.c.length;
                var k = f.x(a);
                var l = SectionData.r(f.i[f.i.length - 1]);
                var m = new Array(l._inner[k].count);
                l._inner[k].values.copyTo(m, 0);
                j.summaryResults = m;
                return j;
            }
        }
        return null;
    };
    VirtualDataSource.prototype.ck = function (a) {
        if (this.aj && this.cv.q) {
            var b = false;
            var c = this.cu(a);
            if (c == null) {
                c = this.cv.d();
                if (this.cj.length > 0 && a > c.ad) {
                    b = true;
                }
            }
            var d = c.af;
            if (this.shouldEmitSectionHeaders && a >= d && a < d + c.v()) {
                b = true;
            }
            if (a - (d + c.v() - 1) <= c.aa + c.ah) {
                b = true;
            }
            if (this.shouldEmitSectionFooters) {
                if (a <= c.ad && a >= c.ad - c.c.length - c.ag) {
                    b = true;
                }
            }
            else if (c.ag > 0) {
                if (a > c.ad - c.ag && a <= c.ad) {
                    b = true;
                }
            }
            var e = a - c.t;
            var f = truncate(Math.floor(e / this.actualPageSize));
            var g = e % this.actualPageSize;
            if (b) {
                g = -1;
            }
            var h = new Array(2);
            h[0] = f;
            h[1] = g;
            return h;
        }
        else {
            var i = truncate(Math.floor(a / this.actualPageSize));
            var j = a % this.actualPageSize;
            var k = new Array(2);
            k[0] = i;
            k[1] = j;
            return k;
        }
    };
    VirtualDataSource.prototype.cu = function (a) {
        return this.cv.e(a);
    };
    VirtualDataSource.prototype.getItemPropertyAtIndex = function (a, b) {
        if (a > (this.actualCount - 1) - this.dl) {
            return this.du(a, b);
        }
        var c = this.ck(a);
        var d = c[0];
        if (!this.cw.d(d)) {
            if (c[1] == -1) {
                return this.du(a, b);
            }
            return null;
        }
        var e = this.cw.item(d);
        var f = c[1];
        if (f == -1) {
            return this.du(a, b);
        }
        return e.getItemValueAtIndex(f, b);
    };
    VirtualDataSource.prototype.du = function (a, b) {
        var c = this.dt(a);
        if (typeCast(DataSourceSpecialRow.$, c) !== null) {
            return c.getValue(b);
        }
        return null;
    };
    VirtualDataSource.prototype.d7 = function (a) {
        if (!this.c4.containsKey(a)) {
            this.c4.addItem(a, 1);
        }
        else {
            this.c4.item(a, this.c4.item(a) + 1);
        }
    };
    VirtualDataSource.prototype.d5 = function (a) {
        if (this.c4.containsKey(a)) {
            this.c4.item(a, this.c4.item(a) - 1);
            if (this.c4.item(a) <= 0) {
                this.c4.removeItem(a);
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.removePageRequest(a);
                }
            }
        }
    };
    VirtualDataSource.prototype.addCandidate = function (a, b) {
        var c = false;
        if (!this.c3.containsKey(a)) {
            var d = new List$1(Number_$type, 0);
            var e = this.transformPage(a);
            for (var f = 0; f < e.length; f++) {
                var g = e[f];
                if (!this.cw.d(g)) {
                    d.add(g);
                    this.d7(g);
                    var h = this.c4.item(g);
                    if (h == 1 && this.actualDataProvider != null) {
                        this.actualDataProvider.addPageRequest(g, b);
                    }
                    c = true;
                }
            }
            if (d.count > 0) {
                this.c3.addItem(a, d.toArray());
            }
        }
        return c;
    };
    VirtualDataSource.prototype.removeCandidate = function (a) {
        if (this.c3.containsKey(a)) {
            for (var b = 0; b < this.c3.item(a).length; b++) {
                var c = this.c3.item(a)[b];
                this.d5(c);
            }
            this.c3.removeItem(a);
        }
    };
    VirtualDataSource.prototype.transformPage = function (a) {
        var b = [a];
        if (this.aj && this.cv.q) {
            var c = a * this.actualPageSize;
            var d = c + this.actualPageSize - 1;
            var e = this.cu(c);
            var f = new List$1(Number_$type, 0);
            for (var g = c; g <= d; g++) {
                if (e == null) {
                    break;
                }
                if (g > e.ad) {
                    if (e.ae < this.cv.t.count - 1) {
                        e = this.cv.t._inner[e.ae + 1];
                    }
                    else {
                        break;
                    }
                }
                if (!e.p || (g >= e.af && g <= e.af + (e.v() - 1) + e.aa)) {
                    continue;
                }
                var h = g - e.t;
                var i = intDivide(h, this.actualPageSize);
                if (!f.contains(i)) {
                    f.add(i);
                }
            }
            b = f.toArray();
        }
        return b;
    };
    VirtualDataSource.prototype.getUnrealizedCount = function () {
        var a = this.cw.g * this.actualPageSize;
        var b = this.actualCount - a;
        return b;
    };
    VirtualDataSource.prototype.onSetItemOverride = function (a, b, c) {
        _super.prototype.onSetItemOverride.call(this, a, b, c);
        var d = this.ck(a);
        var e = d[0];
        if (this.cw.d(e)) {
            this.cw.j(e);
        }
    };
    VirtualDataSource.prototype.refreshInternalOverride = function () {
        _super.prototype.refreshInternalOverride.call(this);
        this.actualPageSizePopulated = false;
        var a = this.actualCount != 0;
        this.cy = true;
        if (!this.cz) {
            this.resetCache();
            if (a) {
                this.onClearItems();
            }
            this.ce = null;
            this.cj = null;
            this.dl = 0;
            this.cv.v();
        }
        else {
            this.cz = false;
            if (a) {
                this.onClearItems();
            }
        }
        this.eb();
        this.ct.au();
        this.cy = false;
    };
    VirtualDataSource.prototype.eb = function () {
        var e_1, _a;
        if (this.actualDataProvider != null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.c3.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    for (var c = 0; c < a.length; c++) {
                        var b = a[c];
                        this.actualDataProvider.addPageRequest(b, 1);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    VirtualDataSource.prototype.onClearItemsOverride = function () {
        _super.prototype.onClearItemsOverride.call(this);
        if (!this.cy) {
            this.queueAutoRefresh();
        }
    };
    VirtualDataSource.prototype.onInsertItemOverride = function (a, b) {
        _super.prototype.onInsertItemOverride.call(this, a, b);
        this.queueAutoRefresh();
    };
    VirtualDataSource.prototype.onRemoveItemOverride = function (a, b) {
        _super.prototype.onRemoveItemOverride.call(this, a, b);
        this.queueAutoRefresh();
    };
    VirtualDataSource.prototype.get_isItemIndexLookupSupported = function () {
        return true;
    };
    VirtualDataSource.prototype.get_isKeyIndexLookupSupported = function () {
        return true;
    };
    VirtualDataSource.prototype.indexOfItem = function (a) {
        var b = this.cw.b;
        var c = b.o;
        var d = b.q;
        var e = d.count;
        var f = b.p;
        for (var g = 0; g < e; g++) {
            if (f._inner[g]) {
                continue;
            }
            var h = d._inner[g].b;
            var i = h.count();
            for (var j = 0; j < i; j++) {
                if (this.c1(h.getItemAtIndex(j), a)) {
                    var k = typeGetValue(c._inner[g]);
                    var l = k * this.actualPageSize;
                    return l + j;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
            return this.actualDataProvider.indexOfItem(a);
        }
        return -1;
    };
    VirtualDataSource.prototype.c1 = function (a, b) {
        if (a == null && b == null) {
            return true;
        }
        if (a == null || b == null) {
            return false;
        }
        return Base.equalsStatic(a, b);
    };
    VirtualDataSource.prototype.indexOfKey = function (a) {
        var b = this.actualPrimaryKey;
        if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
            return -1;
        }
        this.ensureComparables(this.actualSchema);
        var c = this.cs();
        if (this.aj && this.shouldEmitSectionHeaders && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
            if (this.cv.t.count > 0) {
                for (var d = 0; d < this.cv.t.count; d++) {
                    var e = this.cv.t._inner[d];
                    var f = new DataSourceSpecialRow();
                    for (var g = 0; g < e.e.length; g++) {
                        var h = e.e[g];
                        var i = e.f[g];
                        f.setSectionValue(h, i);
                    }
                    if (c.i(f, a) == 0) {
                        return d;
                    }
                }
            }
        }
        var j = this.cw.b;
        var k = j.o;
        var l = j.q;
        var m = l.count;
        var n = j.p;
        for (var o = 0; o < m; o++) {
            if (n._inner[o]) {
                continue;
            }
            var p = l._inner[o].b;
            var q = p.count();
            for (var r = 0; r < q; r++) {
                if (c.i(p.getItemAtIndex(r), a) == 0) {
                    var s = typeGetValue(k._inner[o]);
                    var t = s * this.actualPageSize;
                    return t + r;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
            return this.actualDataProvider.indexOfKey(a);
        }
        return -1;
    };
    VirtualDataSource.prototype.cs = function () {
        var a = new Array(this.actualPrimaryKey.length);
        for (var b = 0; b < a.length; b++) {
            a[b] = 0;
        }
        return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.ci, this);
    };
    VirtualDataSource.prototype.getStickyRowPriority = function (a) {
        var b = this.getRowType(a);
        switch (b) {
            case 1: return 100 - this.getRowLevel(a);
            case 2: return 99 - this.getRowLevel(a);
            case 3:
            case 5: return 2;
            case 4: return 3;
        }
        return 1;
    };
    VirtualDataSource.prototype.unpinRow = function (a) {
        _super.prototype.unpinRow.call(this, a);
    };
    VirtualDataSource.prototype.pinRow = function (a) {
        _super.prototype.pinRow.call(this, a);
    };
    VirtualDataSource.prototype.isRowPinned = function (a) {
        return _super.prototype.isRowPinned.call(this, a);
    };
    VirtualDataSource.prototype.getStickyRowsInRange = function (a, b) {
        if ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0)) {
            return null;
        }
        var c = this.cu(a);
        var d = this.cu(b);
        if (this.cv.t.count > 0) {
            if (this.cv.t.count == 1) {
                c = this.cv.t._inner[0];
                d = this.cv.t._inner[0];
            }
            else {
                c = this.cv.e(a);
                if (c != null) {
                    while (c.z != -1) {
                        c = this.cv.t._inner[c.z];
                    }
                }
                d = this.cv.e(b);
                if (b >= this.actualCount - this.dl) {
                    d = this.cv.d();
                }
            }
        }
        else if (this.dl > 0) {
            var e = new List$1(Number_$type, 0);
            for (var f = this.actualCount - this.dl; f < this.actualCount; f++) {
                e.add(f);
            }
            return e.toArray();
        }
        if (c == null || d == null) {
            return null;
        }
        if (c.ae == this.dd && c.aa == this.df && c.af == this.dg && c.ad == this.de && c.ah == this.di && c.ag == this.dh && d.ae == this.c6 && d.aa == this.c8 && d.af == this.c9 && d.ad == this.c7 && d.ah == this.db && d.ag == this.da && this.dl == this.dc) {
            return this.cf;
        }
        this.dd = c.ae;
        this.c6 = d.ae;
        this.df = c.aa;
        this.c8 = d.aa;
        this.dg = c.af;
        this.c9 = d.af;
        this.de = c.ad;
        this.c7 = d.ad;
        this.db = d.ah;
        this.da = d.ag;
        this.di = c.ah;
        this.dh = c.ag;
        this.dc = this.dl;
        var g = new List$1(Number_$type, 0);
        for (var h = c.ae; h <= d.ae; h++) {
            var i = this.cv.t._inner[h];
            var j = i.c.length;
            var k = i.v();
            if (this.shouldEmitSectionHeaders && this.aj) {
                for (var l = 0; l < i.c.length; l++) {
                    if (i.a[l] != null) {
                        var m = i.af + i.b[l];
                        g.add(m);
                    }
                    if (!i.c[l]) {
                        break;
                    }
                }
            }
            if (i.p) {
                for (var n = 0; n < i.ah; n++) {
                    g.add(i.af + n + k);
                }
                if (this.shouldEmitShiftedRows) {
                    for (var o = 0; o < i.aa; o++) {
                        g.add(i.af + o + j);
                    }
                }
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                        for (var p = i.ag - 1; p >= 0; p--) {
                            if (this.shouldEmitSectionFooters) {
                                g.add(i.ad - k - p);
                            }
                            else {
                                g.add(i.ad - p);
                            }
                        }
                    }
                }
            }
            if (this.shouldEmitSectionFooters && this.aj) {
                for (var q = i.c.length - 1; q >= 0; q--) {
                    if (!i.c[q]) {
                        break;
                    }
                    g.add(i.ad - q);
                }
            }
        }
        for (var r = this.actualCount - this.dl; r < this.actualCount; r++) {
            g.add(r);
        }
        this.cf = g.toArray();
        return this.cf;
    };
    VirtualDataSource.prototype.isExclusivelySticky = function (a) {
        var b = this.getRowType(a);
        return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
    };
    VirtualDataSource.prototype.getRowType = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            var c = b.rowType;
            if (this.isSectionHeaderNormalRow && c == 1) {
                return 0;
            }
            return c;
        }
        return 0;
    };
    VirtualDataSource.prototype.getIsRowExpandedAtIndex = function (a) {
        var b = this.cv.e(a);
        if (b == null) {
            b = this.cv.d();
        }
        for (var c = 0; c < b.a.length; c++) {
            if (b.a[c] != null) {
                if (a == b.af + b.b[c]) {
                    return b.c[c];
                }
            }
        }
        return _super.prototype.getIsRowExpandedAtIndex.call(this, a);
    };
    VirtualDataSource.prototype.setIsRowExpandedAtIndex = function (a, b) {
        var c = this.cv.e(a);
        if (c == null) {
            c = this.cv.d();
        }
        for (var d = 0; d < c.a.length; d++) {
            if (c.a[d] != null) {
                if (a == c.af + c.b[d]) {
                    var e = false;
                    var f = c.a[d];
                    if (this.c2.containsKey(f) && this.c2.item(f) != b) {
                        var g = this.c2.item(f);
                        if (b == this.isSectionExpandedDefault) {
                            this.c2.removeItem(f);
                        }
                        else {
                            this.c2.item(f, b);
                        }
                        e = true;
                        this.onRowExpansionChanged(a, g, b);
                    }
                    else if (b != this.isSectionExpandedDefault) {
                        this.c2.addItem(f, b);
                        e = true;
                        this.onRowExpansionChanged(a, this.isSectionExpandedDefault, b);
                    }
                    if (e) {
                        this.cv.v();
                        this.d9();
                        this.cz = true;
                        if (this.actualCount != this.cv.u) {
                            this.actualCount = this.cv.u + this.dl;
                        }
                        else {
                            this.queueAutoRefresh();
                        }
                    }
                    break;
                }
            }
        }
    };
    VirtualDataSource.prototype.getRowLevel = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.level;
        }
        if (this.isGroupingSupported) {
            if (this.sectionHeaderDisplayMode == 1) {
                return this.groupDescriptions.k.count;
            }
            else if (this.groupDescriptions.k.count > 0) {
                return 1;
            }
        }
        return 0;
    };
    VirtualDataSource.prototype.getRootSummaryRowCount = function () {
        return this.dl;
    };
    VirtualDataSource.prototype.dx = function (a) {
        var b = "";
        for (var c = 0; c < a.e.length; c++) {
            b += a.e[c] + ":" + a.f[c];
        }
        return b;
    };
    VirtualDataSource.prototype.dy = function (a, b) {
        if (this.sectionHeaderDisplayMode == 0) {
            return this.dx(a);
        }
        var c = "";
        for (var d = 0; d < a.e.length; d++) {
            c += a.e[d] + ":" + a.f[d] + ":";
        }
        c += b;
        return c;
    };
    VirtualDataSource.prototype.getRootSummaryResults = function () {
        return this.cj;
    };
    VirtualDataSource.prototype.getSectionSummaryResults = function (a) {
        if (this.cv.t.count > 0 && a >= 0 && a < this.cv.t.count) {
            return this.cv.t._inner[a].i;
        }
        return null;
    };
    VirtualDataSource.prototype.clone = function () {
        return null;
    };
    VirtualDataSource.prototype.cloneProperties = function (a) {
        _super.prototype.cloneProperties.call(this, a);
        var b = typeCast(VirtualDataSource.$, a);
        if (b != null) {
            b.pageSizeRequested = this.pageSizeRequested;
            b.maxCachedPages = this.maxCachedPages;
        }
    };
    VirtualDataSource.$t = markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
    return VirtualDataSource;
}(BaseDataSource));
export { VirtualDataSource };
//# sourceMappingURL=VirtualDataSource.js.map
