import { Description } from "./Description";
import { ColumnDescription } from "./ColumnDescription";
import { SectionHeaderDescription } from "./SectionHeaderDescription";
import { SummaryRowRootDescription } from "./SummaryRowRootDescription";
import { SummaryRowSectionDescription } from "./SummaryRowSectionDescription";
import { RowSeparatorDescription } from "./RowSeparatorDescription";
import { HeaderRowSeparatorDescription } from "./HeaderRowSeparatorDescription";
import { HeaderSeparatorDescription } from "./HeaderSeparatorDescription";
import { ColumnResizingSeparatorDescription } from "./ColumnResizingSeparatorDescription";
import { ColumnMovingSeparatorDescription } from "./ColumnMovingSeparatorDescription";
import { PinnedAreaSeparatorDescription } from "./PinnedAreaSeparatorDescription";
import { GridAnimationSettingsDescription } from "./GridAnimationSettingsDescription";
import { GridCellPositionDescription } from "./GridCellPositionDescription";
import { Type } from "./type";
/**
 * @hidden
 */
export declare class DataGridDescription extends Description {
    static $t: Type;
    private g;
    columns: ColumnDescription[];
    private eg;
    width: string;
    private dn;
    height: string;
    private cg;
    background: string;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private c5;
    columnResizingMode: string;
    private cx;
    columnMovingMode: string;
    private ad;
    sectionHeader: SectionHeaderDescription;
    private af;
    summaryRowRoot: SummaryRowRootDescription;
    private ah;
    summaryRowSection: SummaryRowSectionDescription;
    private ab;
    rowSeparator: RowSeparatorDescription;
    private v;
    headerRowSeparator: HeaderRowSeparatorDescription;
    private x;
    headerSeparator: HeaderSeparatorDescription;
    private p;
    columnResizingSeparator: ColumnResizingSeparatorDescription;
    private n;
    columnMovingSeparator: ColumnMovingSeparatorDescription;
    private z;
    pinnedAreaSeparator: PinnedAreaSeparatorDescription;
    private h;
    dataSourceDesiredProperties: string[];
    private da;
    density: string;
    private bx;
    actualRowHeight: number;
    private b3;
    rowHeight: number;
    private bd;
    defaultColumnMinWidth: number;
    private bw;
    actualHeaderHeight: number;
    private b0;
    headerHeight: number;
    private c9;
    dataSourceRef: string;
    private dh;
    headerClickAction: string;
    private aj;
    autoGenerateColumns: boolean;
    private b4;
    rowSeparatorHeight: number;
    private ap;
    isPlaceholderRenderingEnabled: boolean;
    private cs;
    columnAddingAnimationMode: string;
    private c3;
    columnPropertyUpdatingAnimationMode: string;
    private ck;
    cellDataLoadedAnimationMode: string;
    private dr;
    rowSelectionAnimationMode: string;
    private cq;
    cellSelectionAnimationMode: string;
    private r;
    animationSettings: GridAnimationSettingsDescription;
    private c4;
    columnResizingAnimationMode: string;
    private c8;
    columnShowingAnimationMode: string;
    private cw;
    columnMovingAnimationMode: string;
    private cv;
    columnHidingAnimationMode: string;
    private ct;
    columnExchangingAnimationMode: string;
    private d4;
    selectionMode: string;
    private ce;
    activationMode: string;
    private d3;
    selectionBehavior: string;
    private ak;
    isColumnOptionsEnabled: boolean;
    private an;
    isGroupRowSticky: boolean;
    private ao;
    isHeaderSeparatorVisible: boolean;
    private cp;
    cellSelectedBackground: string;
    private dx;
    sectionHeaderSelectedBackground: string;
    private d7;
    summaryRootBackground: string;
    private ec;
    summarySectionBackground: string;
    private be;
    pinnedRowOpacity: number;
    private d6;
    stickyRowBackground: string;
    private dq;
    pinnedRowBackground: string;
    private dp;
    lastStickyRowBackground: string;
    private t;
    activeCell: GridCellPositionDescription;
    private ci;
    cellBackground: string;
    private cr;
    cellTextColor: string;
    private dk;
    headerSortIndicatorColor: string;
    private dl;
    headerSortIndicatorStyle: string;
    private _cellFontFamily;
    cellFontFamily: string;
    private _cellFontSize;
    cellFontSize: number;
    private _cellFontStyle;
    cellFontStyle: string;
    private _cellFontWeight;
    cellFontWeight: string;
    private dw;
    sectionHeaderBackground: string;
    private dy;
    sectionHeaderTextColor: string;
    private _sectionHeaderFontFamily;
    sectionHeaderFontFamily: string;
    private _sectionHeaderFontSize;
    sectionHeaderFontSize: number;
    private _sectionHeaderFontStyle;
    sectionHeaderFontStyle: string;
    private _sectionHeaderFontWeight;
    sectionHeaderFontWeight: string;
    private _summaryRootLabelFontFamily;
    summaryRootLabelFontFamily: string;
    private _summaryRootLabelFontSize;
    summaryRootLabelFontSize: number;
    private _summaryRootLabelFontStyle;
    summaryRootLabelFontStyle: string;
    private _summaryRootLabelFontWeight;
    summaryRootLabelFontWeight: string;
    private _summarySectionLabelFontFamily;
    summarySectionLabelFontFamily: string;
    private _summarySectionLabelFontSize;
    summarySectionLabelFontSize: number;
    private _summarySectionLabelFontStyle;
    summarySectionLabelFontStyle: string;
    private _summarySectionLabelFontWeight;
    summarySectionLabelFontWeight: string;
    private ea;
    summaryRootValueTextColor: string;
    private _summaryRootValueFontFamily;
    summaryRootValueFontFamily: string;
    private _summaryRootValueFontSize;
    summaryRootValueFontSize: number;
    private _summaryRootValueFontStyle;
    summaryRootValueFontStyle: string;
    private _summaryRootValueFontWeight;
    summaryRootValueFontWeight: string;
    private _summarySectionValueFontFamily;
    summarySectionValueFontFamily: string;
    private _summarySectionValueFontSize;
    summarySectionValueFontSize: number;
    private _summarySectionValueFontStyle;
    summarySectionValueFontStyle: string;
    private _summarySectionValueFontWeight;
    summarySectionValueFontWeight: string;
    private ef;
    summarySectionValueTextColor: string;
    private d8;
    summaryRootLabelTextColor: string;
    private ed;
    summarySectionLabelTextColor: string;
    private d9;
    summaryRootSelectedBackground: string;
    private ee;
    summarySectionSelectedBackground: string;
    private b2;
    pinnedAreaSeparatorWidth: number;
    private b1;
    headerSeparatorWidth: number;
    private dj;
    headerSeparatorBackground: string;
    private dg;
    headerBackground: string;
    private dm;
    headerTextColor: string;
    private _headerFontFamily;
    headerFontFamily: string;
    private _headerFontSize;
    headerFontSize: number;
    private _headerFontStyle;
    headerFontStyle: string;
    private _headerFontWeight;
    headerFontWeight: string;
    private ds;
    rowSeparatorBackground: string;
    private di;
    headerRowSeparatorBackground: string;
    private dv;
    rowSeparatorStickyRowBackground: string;
    private dt;
    rowSeparatorLastStickyRowBackground: string;
    private du;
    rowSeparatorPinnedRowBackground: string;
    private bz;
    columnResizingSeparatorWidth: number;
    private by;
    columnMovingSeparatorWidth: number;
    private c6;
    columnResizingSeparatorBackground: string;
    private cy;
    columnMovingSeparatorBackground: string;
    private at;
    shiftSectionContent: boolean;
    private cz;
    columnOptionsIconAlignment: string;
    private c1;
    columnOptionsIconColor: string;
    private c0;
    columnOptionsIconBehavior: string;
    private ch;
    border: string;
    private a5;
    borderWidthBottom: number;
    private a6;
    borderWidthLeft: number;
    private a7;
    borderWidthRight: number;
    private a8;
    borderWidthTop: number;
    private ba;
    cornerRadiusBottomRight: number;
    private a9;
    cornerRadiusBottomLeft: number;
    private bb;
    cornerRadiusTopLeft: number;
    private bc;
    cornerRadiusTopRight: number;
    private eb;
    summaryScope: string;
    private al;
    isGroupCollapsable: boolean;
    private de;
    groupHeaderDisplayMode: string;
    private am;
    isGroupExpandedDefault: boolean;
    private df;
    groupSummaryDisplayMode: string;
    private i;
    primaryKey: string[];
    private f;
    actualPrimaryKey: string[];
    private as;
    reactsToSortChanges: boolean;
    private ar;
    reactsToGroupChanges: boolean;
    private aq;
    reactsToFilterChanges: boolean;
    private dc;
    filterExpressionsChangingRef: string;
    private db;
    filterExpressionsChangedRef: string;
    private cn;
    cellPreviewPointerDownRef: string;
    private co;
    cellPreviewPointerUpRef: string;
    private cl;
    cellPointerDownRef: string;
    private cm;
    cellPointerUpRef: string;
    private cj;
    cellClickedRef: string;
    private d5;
    sortDescriptionsChangedRef: string;
    private dd;
    groupDescriptionsChangedRef: string;
    private cu;
    columnHiddenChangedRef: string;
    private c2;
    columnPinnedChangedRef: string;
    private c7;
    columnsAutoGeneratedRef: string;
    private d1;
    selectedItemsChangedRef: string;
    private d2;
    selectedKeysChangedRef: string;
    private d0;
    selectedCellsChangedRef: string;
    private cf;
    activeCellChangedRef: string;
    private dz;
    selectedCellRangesChangedRef: string;
}
