import { Type } from "./type";
/**
 * Enumerates different calculation modes for summaries in the data source.
 */
export declare enum DataSourceSummaryScope {
    /**
     * Summaries are calculated for both the root and section level.
     */
    Both = 0,
    /**
     * Summaries are only calculated at the root level.
     */
    Root = 1,
    /**
     * Summaries are only calculated at the group level.
     */
    Groups = 2,
    /**
     * Summaries are not calculated at all.
     */
    None = 3
}
/**
 * @hidden
 */
export declare let DataSourceSummaryScope_$type: Type;
