import { Description } from "./Description";
import { PointDescription } from "./PointDescription";
import { RectDescription } from "./RectDescription";
import { SeriesDescription } from "./SeriesDescription";
import { Type } from "./type";
/**
 * @hidden
 */
export declare abstract class SeriesViewerDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private h;
    crosshairPoint: PointDescription;
    private r;
    animateSeriesWhenAxisRangeChanges: boolean;
    private k;
    effectiveViewport: RectDescription;
    private m;
    windowRect: RectDescription;
    private w;
    useTiledZooming: boolean;
    private v;
    preferHigherResolutionTiles: boolean;
    private bs;
    zoomTileCacheSize: number;
    private br;
    highlightingTransitionDuration: number;
    private t;
    isPagePanningAllowed: boolean;
    private bz;
    contentHitTestMode: string;
    private bv;
    actualContentHitTestMode: string;
    private u;
    isSurfaceInteractionDisabled: boolean;
    private cu;
    windowResponse: string;
    private a1;
    windowRectMinWidth: number;
    private b0;
    crosshairVisibility: string;
    private b6;
    plotAreaBackground: string;
    private b1;
    defaultInteraction: string;
    private b8;
    rightButtonDefaultInteraction: string;
    private b2;
    dragModifier: string;
    private b5;
    panModifier: string;
    private l;
    previewRect: RectDescription;
    private az;
    windowPositionHorizontal: number;
    private a0;
    windowPositionVertical: number;
    private by;
    chartTitle: string;
    private cq;
    titleHorizontalAlignment: string;
    private ck;
    subtitleHorizontalAlignment: string;
    private cs;
    titleTextStyle: string;
    private cm;
    subtitleTextStyle: string;
    private cr;
    titleTextColor: string;
    private cl;
    subtitleTextColor: string;
    private ax;
    titleTopMargin: number;
    private av;
    titleLeftMargin: number;
    private aw;
    titleRightMargin: number;
    private at;
    titleBottomMargin: number;
    private as;
    subtitleTopMargin: number;
    private aq;
    subtitleLeftMargin: number;
    private ar;
    subtitleRightMargin: number;
    private ao;
    subtitleBottomMargin: number;
    private cg;
    subtitle: string;
    private ay;
    topMargin: number;
    private al;
    leftMargin: number;
    private an;
    rightMargin: number;
    private aj;
    bottomMargin: number;
    private ai;
    autoMarginWidth: number;
    private ah;
    autoMarginHeight: number;
    private s;
    isAntiAliasingEnabledDuringInteraction: boolean;
    private am;
    pixelScalingRatio: number;
    private ak;
    interactionPixelScalingRatio: number;
    private ae;
    actualPixelScalingRatio: number;
    private ad;
    actualInteractionPixelScalingRatio: number;
    private j;
    actualWindowRect: RectDescription;
    private af;
    actualWindowPositionHorizontal: number;
    private ag;
    actualWindowPositionVertical: number;
    private b9;
    seriesCursorMouseMoveRef: string;
    private cc;
    seriesMouseLeftButtonDownRef: string;
    private cd;
    seriesMouseLeftButtonUpRef: string;
    private ce;
    seriesMouseMoveRef: string;
    private ca;
    seriesMouseEnterRef: string;
    private cb;
    seriesMouseLeaveRef: string;
    private ct;
    windowRectChangedRef: string;
    private cf;
    sizeChangedRef: string;
    private bw;
    actualWindowRectChangedRef: string;
    private b3;
    gridAreaRectChangedRef: string;
    private b7;
    refreshCompletedRef: string;
    private f;
    series: SeriesDescription[];
    private b4;
    legendRef: string;
    private bx;
    background: string;
    private cn;
    titleFontFamily: string;
    private au;
    titleFontSize: number;
    private cp;
    titleFontWeight: string;
    private co;
    titleFontStyle: string;
    private ch;
    subtitleFontFamily: string;
    private ap;
    subtitleFontSize: number;
    private cj;
    subtitleFontWeight: string;
    private ci;
    subtitleFontStyle: string;
}
