import { ItfConverter as ItfConverter_internal } from "./ItfConverter";
import { IgcAsyncCompletedEventArgs } from './igc-async-completed-event-args';
import { TriangulationSourcePointRecord } from './TriangulationSourcePointRecord';
import { Triangle } from './Triangle';
/**
 * Class for converting Itf files into enumerable triangulations.
*/
export declare class IgcTriangulationDataSource {
    protected createImplementation(): ItfConverter_internal;
    protected _implementation: any;
    readonly i: ItfConverter_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the string path specifying the location of the Itf file.
    */
    /**
     * Sets the string path specifying the location of the Itf file.
    */
    source: string;
    /**
    * Gets the point data.
    */
    getPointData(): TriangulationSourcePointRecord[];
    /**
    * Gets the triangle data.
    */
    getTriangleData(): Triangle[];
    private _importCompleted;
    private _importCompleted_wrapped;
    /**
     * Event raised when the import operation has completed
    */
    importCompleted: (s: IgcTriangulationDataSource, e: IgcAsyncCompletedEventArgs) => void;
}
